# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from stark_ros_msgs/StructuredArray.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

from ._StructuredArrayField import *

class StructuredArray(genpy.Message):
  _md5sum = "6a6b60ae4074e7e86f6fca4cc5177edf"
  _type = "stark_ros_msgs/StructuredArray"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Structured array of data similar to a numpy structured/record array

# Fields in each element
stark_ros_msgs/StructuredArrayField[] fields

# Number of elements
uint32 length

# Array data, unpacked shape is (length * number of fields)
uint8[] data

# Is the data blob bigendian?
bool is_bigendian

================================================================================
MSG: stark_ros_msgs/StructuredArrayField
# One field/entry in a structured array

# Field name
string name

# dtype from enumeration in DTypes.msg
uint8  dtype

# Number of elements in the field (i.e. a vertex may have 3 values)
# Cannot be zero in numpy
uint32 count
"""
  __slots__ = ['fields','length','data','is_bigendian']
  _slot_types = ['stark_ros_msgs/StructuredArrayField[]','uint32','uint8[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       fields,length,data,is_bigendian

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StructuredArray, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.fields is None:
        self.fields = []
      if self.length is None:
        self.length = 0
      if self.data is None:
        self.data = b''
      if self.is_bigendian is None:
        self.is_bigendian = False
    else:
      self.fields = []
      self.length = 0
      self.data = b''
      self.is_bigendian = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_BI().pack(_x.dtype, _x.count))
      _x = self.length
      buff.write(_get_struct_I().pack(_x))
      _x = self.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.is_bigendian
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.fields is None:
        self.fields = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.fields = []
      for i in range(0, length):
        val1 = StructuredArrayField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.dtype, _x.count,) = _get_struct_BI().unpack(str[start:end])
        self.fields.append(val1)
      start = end
      end += 4
      (self.length,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data = str[start:end]
      start = end
      end += 1
      (self.is_bigendian,) = _get_struct_B().unpack(str[start:end])
      self.is_bigendian = bool(self.is_bigendian)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_BI().pack(_x.dtype, _x.count))
      _x = self.length
      buff.write(_get_struct_I().pack(_x))
      _x = self.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.is_bigendian
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.fields is None:
        self.fields = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.fields = []
      for i in range(0, length):
        val1 = StructuredArrayField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.dtype, _x.count,) = _get_struct_BI().unpack(str[start:end])
        self.fields.append(val1)
      start = end
      end += 4
      (self.length,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data = str[start:end]
      start = end
      end += 1
      (self.is_bigendian,) = _get_struct_B().unpack(str[start:end])
      self.is_bigendian = bool(self.is_bigendian)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_BI = None
def _get_struct_BI():
    global _struct_BI
    if _struct_BI is None:
        _struct_BI = struct.Struct("<BI")
    return _struct_BI
